
/************************************************************************/
/*									*/
/*			CSys Labs Incorporated				*/	
/*			    Eugene Engelgau  				*/
/*									*/
/************************************************************************/

/* Example2 places two buttons on the Screen.  One to Start and Stop the text
scrolling and the other to exit the program.  This example uses the 
SetTextWindow command to define a window to scroll and for the text. */

#include <stdio.h>
#include <stdlib.h>
#include <csysdefs.h>
#include <tvio.h>

char * Message = "Welcome to Touch Vision\n";

void main()
{
    bool bStop = 0;		/* Stop = 0 so is running */
    uchar KeyCode;		/* Key code buffer */
    if(StartUp())		/* Establish contact with TVM */
    {
	exit(0);		/* No contact so exit */
    }
    SetEL(1);
    SetAutoRefresh(3);		/* Refresh automatically after every command */
    CursorAttribute(7);		/* Turn cursor ON, underbar */
    SetTextWindow(48,0,239,63);	/* Text window keeps text out of left side */
    SetXY(0,0);			/* Set cursor Upper left of window */
    LoadButtonBuffer("EXIT");	/* Send EXIT string to internal buffer */
    PlaceButton(10,0,0);	/* Places EXIT button top left, code is zero */
    LoadButtonBuffer("STOP");	/* Load test */
    PlaceButton(20,0,2);	/* Places STOP in lower left */
    while(1)			/* Loop till exit */
    {
	if(CheckKEYPRESS())	/* See if a key is pressed */
	{
	    KeyCode = ReadKeyCode();	/* Get key code */
	    if(KeyCode == 10)	/* Leaving progeam */
	    {
		DeleteAllButtons();	/* Delete buttons */
		BlankDisplay();		/* Clear display */
		SetXY(0,0);	 	/* Set cursor upper left */
		InputString("Bye Bye!!!");	/* Say good bys */
	        exit(0);		/* Leave program */
	    }
	    else if(KeyCode == 20)
	    {
	        DeleteButton(20);	/* Remove START or STOP button */
	        if(!bStop)		/* See if running */
	        {
	            bStop = 1;		/* Set stop flag to stop */
                    LoadButtonBuffer("START");	/* Input START string */
	        }
	        else
	        {
	            bStop = 0;		/* Start running */
                    LoadButtonBuffer("STOP");	/* Input STOP string */
	        }
                PlaceButton(20,0,2);	/* Places button in lower left */
	    }
	}
	if(!bStop)
	{
	    InputString(Message);
	}
    }
}
