
/************************************************************************/
/*									*/
/*			CSys Labs Incorporated				*/	
/*			    Eugene Engelgau  				*/
/*									*/
/************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <csysdefs.h>
#include <tvio.h>

/* Example3 does a horizontal plot of a SINE and COSINE function.  It uses
the EXIT, START and STOP keys similar to Example2.  It also uses the 
MoveBlockHoriz to shift the display like a plotter */

void main()
{
    bool bStop = 0;		/* Stop = 0 so is running */
    uchar KeyCode;		/* Key code buffer */
    double Input,Sin,Cos;	/* Double float values */
    int YSin,YCos;
    if(StartUp())		/* Establich contact with TVM */
    {
	exit(0);		/* No contact so exit */
    }
    SetEL(1);
    CursorAttribute(0);		/* Turn cursor ON, underbar */
    SetXY(0,0);			/* Set cursor Upper left of window */
    LoadButtonBuffer("EXIT");	/* Send EXIT string to internal buffer */
    PlaceButton(10,0,0);	/* Places EXIT button top left, code is zero */
    LoadButtonBuffer("STOP");	/* Load test */
    PlaceButton(20,0,2);	/* Places STOP in lower left */
    while(1)			/* Loop till exit */
    {
	if(CheckKEYPRESS())	/* See if a key is pressed */
	{
	    KeyCode = ReadKeyCode();	/* Get key code */
	    if(KeyCode == 10)	/* Leaving progeam */
	    {
		DeleteAllButtons();	/* Delete buttons */
		BlankDisplay();		/* Clear display */
		SetXY(0,0);	 	/* Set cursor upper left */
		InputString("Bye Bye!!!");	/* Say good bys */
		Refresh();
		exit(0);		/* Leave program */
	    }
	    else if(KeyCode == 20)
	    {
	        DeleteButton(20);	/* Remove START of STOP button */
	        if(!bStop)		/* See if running */
	        {
	            bStop = 1;		/* Set stop flag to stop */
                    LoadButtonBuffer("START");	/* Input START string */
	        }
	        else
	        {
	            bStop = 0;		/* Start running */
                    LoadButtonBuffer("STOP");	/* Input STOP string */
	        }
		PlaceButton(20,0,2);	/* Places button in lower left */
		Refresh();
	    }
	}
	if(!bStop)
	{
	    Sin = sin(Input);
	    Cos = cos(Input);
	    if(Input < 100)Input += 0.1;
	    else
	    {
		Input = 0.0;
	    }
	    Sin = Sin * 31;
	    Cos = Cos * 31;
	    SetPixel(239,32 + (int)Sin,1);
	    SetPixel(239,32 + (int)Cos,1);
	    MoveBlockHoriz(46,0,239,63,-1);
	    Refresh();
	}
    }
}
