

/************************************************************************/
/*									*/
/*			CSys Labs Incorporated				*/	
/*			    Eugene Engelgau  				*/
/*									*/
/************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <bios.h>
#include <conio.h>
#include <csysdefs.h>
#include <tvio.h>
#include <ctrl.h>		/* Control key definitions */

/* Example5 does the type writter/screen editor routine */
void main()
{
    char c;
    uchar x,y;
    uchar KeyCode;		/* Key code buffer */
    bool bInsert = 0;
    STRING cBuffA[80];		/* Temp buffer */
    if(StartUp())		/* Establich contact with TVM */
    {
	exit(0);		/* No contact so exit */
    }
    SetEL(1);
    SetAutoRefresh(3);		/* Refresh automatically after every command */
    CursorAttribute(7);		/* Turn cursor ON, underbar */
    SetTextWindow(48,0,239,63);	/* Text window keeps text out of left side */
    SetHeight(12);
    SetXY(0,0);			/* Set cursor Upper left of window */
    LoadButtonBuffer("EXIT");	/* Send EXIT string to internal buffer */
    PlaceButton(10,0,0);	/* Places EXIT button top left, code is zero */
    while(1)			/* Loop till exit */
    {
	if(CheckKEYPRESS())	/* See if a key is pressed */
	{
	    KeyCode = ReadKeyCode();	/* Get key code */
	    if(KeyCode == 10)		/* Leaving progeam */
	    {
		DeleteAllButtons();	/* Delete buttons */
		BlankDisplay();		/* Clear display */
		SetXY(0,0);	 	/* Set cursor upper left */
		InputString("Bye Bye!!!");	/* Say good bys */
	        exit(0);		/* Leave program */
	    }
	}
        if(bioskey(1))
        {
	    c = getch();
	    switch(c)
	    {
	        case 0:			/* Special sequence character */
		    c = getch();
		    switch(c)
		    {
	    	        case 0x4b:	/* Left arrow */
	        	    CursorLeft();
	    	            break;
	    	        case 0x4d:	/* Right arrow */
	        	    CursorRight();
	    	            break;
	    	        case 0x48:	/* Up arrow */
	        	    CursorUp();
	    	            break;
	    	        case 0x50:	/* Down arrow */
	        	    CursorDown();
	    	            break;
	    	        case 0x47:	/* Home */
	        	    SetXY(0,0);
	    	            break;
		        case 0x52:	/* Insert mode */
			    if(!bInsert)
			    {
			        bInsert = 1;
			        CursorAttribute(3);	/* Block cursor */
			    }
			    else
			    {
			        bInsert = 0;
			        CursorAttribute(7);	/* Underline cursor */
			    }
			    break;
	    	        case 0x53:		/* Delete key */
		            ReadXY(&x,&y);	/* get new XY Cursor position */
		            MoveBlockHoriz(x,y,239,y+10,-8);/* Pull line in */
	    	            break;
		    }
		    break;
	        case CTRL_H:
		    ReadXY(&x,&y);	/* get XY Cursor position */
		    if(x > 50)		/* See if cursor already left  */
		    {
		        CursorLeft();	/* Step cursor left */
		        ReadXY(&x,&y);	/* get new XY Cursor position */
		        MoveBlockHoriz(x,y,239,y+10,-8);/* Pull line in */
		    }
		    break;
	        case CTRL_M:		/* CR key */
		    bInsert = 0;
		    CursorAttribute(7);
		    SetX(0);
		    CursorDown();
		    break;
	        default:
		    if(c >= ' ')
		    {
		        if(bInsert)
		        {
			    ReadXY(&x,&y);
			    if(x < (239 - 7))
			    {
		                MoveBlockHoriz(x,y,239,y+10,8);/* Move line out */
			    }
			    else
			    {
			        bInsert = 0;
			        CursorAttribute(7);
			    }
		        }
		        sprintf(cBuffA,"%c",c);
		        InputString(cBuffA);
		    }
		    break;
	    }
	}
    }
}
