
/************************************************************************/
/*									*/
/*			CSys Labs Incorporated				*/	
/*			    Eugene Engelgau  				*/
/*									*/
/************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <csysdefs.h>
#include <tvios.h>

/* This example demonstrates how to use the serial interface.  This
example is the same as example4, except it is serial. */
/*  Please note that the only difference between this example and example4
is that this example has a different start up call and needs the TVIOS.C
source compiled in.  Also note that there is no Refresh instruction since the
TVM24128 does not need it. */

void main()
{
    bool bStop = 0;		/* Stop = 0 so is running */
    uchar KeyCode;		/* Key code buffer */
    double Input,Sin,Cos;	/* Double float values */
    int YSin,YCos;
    uint X = 46;
    if(StartUp(COM1,IRQDEF,B38400,"XONXOFF"))/* Establish contact with TVM */
    {
	exit(0);		/* No contact so exit */
    }
    SetEL(1);
    CursorAttribute(0);		/* Turn cursor ON, underbar */
    SetXY(0,0);			/* Set cursor Upper left of window */
    LoadButtonBuffer("EXIT");	/* Send EXIT string to internal buffer */
    PlaceButton(10,0,0);	/* Places EXIT button top left, code is zero */
    LoadButtonBuffer("STOP");	/* Load test */
    PlaceButton(20,0,2);	/* Places STOP in lower left */
    while(1)			/* Loop till exit */
    {
	if(CheckKEYPRESS())	/* See if a key is pressed */
	{
	    KeyCode = ReadKeyCode();	/* Get key code */
	    if(KeyCode == 10)	/* Leaving progeam */
	    {
		DeleteAllButtons();	/* Delete buttons */
		BlankDisplay();		/* Blank display */
		SetXY(0,0);	 	/* Set cursor upper left */
		InputString("Bye Bye!!!");	/* Say good by's */
		exit(0);		/* Leave program */
	    }
	    else if(KeyCode == 20)
	    {
		DeleteButton(20);	/* Remove START or STOP button */
		if(!bStop)		/* See if running */
		{
		    bStop = 1;		/* Set stop flag to stop */
		    LoadButtonBuffer("START");	/* Input START string */
		}
		else
		{
		    bStop = 0;		/* Start running */
		    LoadButtonBuffer("STOP");	/* Input STOP string */
		}
		PlaceButton(20,0,2);	/* Places button in lower left */
	    }
	}
	if(!bStop)
	{
	    Sin = sin(Input);
	    Cos = cos(Input);
	    if(Input < 100)Input += 0.1;
	    else
	    {
		Input = 0.0;
	    }
	    Sin = Sin * 31;
	    Cos = Cos * 31;
	    DrawVert(X,0,-64,0);	/* Clear old data */
	    SetPixel(X,32 + (int)Sin,1);
	    SetPixel(X,32 + (int)Cos,1);
	    X++;
	    if(X > 239)
	    {
		X = 46;
	    }
	}
    }
}
