#ifndef  _SSERVER_H
#define _SSERVER_H

/************************************************************************/
/*									*/
/*		Copyright 1991, CSys Labs Incorporated,			*/	
/*		   	238 So. Hillview Dr.				*/
/*		   	Milpitas, Ca. 95035				*/
/*									*/
/************************************************************************/

#include <csysdefs.h>

/* SSERVER.H is the header file for the sserver.c */

/* Use the following definitions to open/close the serial port */

#define COM1 		0
#define COM2 		1
#define COM3		2
#define COM4		3

#define IRQ3		0
#define IRQ4		1
#define IRQDEF		-1

#define B300		0
#define B600		1
#define B1200		2
#define B2400		3
#define B4900		4
#define B9600		5
#define B19200		6
#define B38400		7

#define SIZEOFRB	0x1000		/* RXBuffer size */
#define RBMASK		(SIZEOFRB - 1)  /* RXBuffer index mask */

/* Special code definitions */
#define DC1 0x11	/* XON */
#define DC2 0x12        /* Key press signal */
#define DC3 0x13        /* XOFF signal */
#define XON DC1
#define XOFF DC3
#define RTSCTS 1
#define XONXOFF 2
/* Use these global variables to get to the buffer */
extern uchar RBuffer[];		/* Recieve buffer */
extern uint RBIn;		/* Input pointer */
extern bool bXON;		/* Set to use XON protocall */

#ifdef __cplusplus
extern "C"
{
#endif
bool OpenServer(int Port,int IRQ,uint iBaud,STRING * Protocol);
void CloseServer();
void interrupt sserver();
void SendString(STRING * pS);	/* Puts a string to the UART */
void SendBlock(char * pC,uint Count);/* Sends a block of characters to the UART */
#ifdef __cplusplus
}
#endif


#endif  /* _SSERVER_H */