#ifndef _TVIO_H
#define _TVIO_H

/************************************************************************/
/*									*/
/*		Copyright 1991, CSys Labs Incorporated,			*/
/*		   	238 So. Hillview Dr.				*/
/*		   	Milpitas, Ca. 95035				*/
/*									*/
/************************************************************************/

/* tvio.h is the tvio header file. */

/******* This header file can be used with normal ANSI C **********/

#define TVM2464_TYPE	0
#define TVM24128_TYPE	1

extern int ModuleType;		/* Stores module type set by CheckModuleType */

#ifdef __cplusplus
extern "C"
{
#endif
    bool StartUp();				/* HARDWARE DEPENDENT */
    bool Echo();
    void CheckModuleType();	/* This sets the ModuleType global variable. */
    void SetBase(uint B);
    uchar GetStatus(void);			/* HARDWARE DEPENDENT */
    bool CheckIBF(void);
    bool CheckOBF(void);
    bool CheckERROR(void);
    bool CheckKEYPRESS(void);
    bool CheckCPUBUSY(void);
    bool SendChar(uchar uAddr,uchar cChar);	/* HARDWARE DEPENDENT */
    bool GetData(uchar * pData);		/* HARDWARE DEPENDENT */
    bool TestError(STRING * pString,...);
    bool SelectFont(uchar xxx);
    void SetFontAttribute(uchar ab);
    void SetFontGrayPalet(uchar Palet);
    void SetFontPlane(uchar Plane);
    bool DownLoadFont(STRING * sFileName,uint FontNumber);
    bool GetFontChar(FILE * pFile,uchar * pChar);
    void SetXY(uchar XPos,uchar YPos);
    bool ReadXY(uchar * XPos,uchar * YPos);
    void CursorUp(void);
    void CursorDown(void);
    void CursorLeft(void);
    void CursorRight(void);
    void SetX(uchar XPos);
    void SetY(uchar YPos);
    void CursorAttribute(uchar abc);
    void SetTextWindow(uchar AX,uchar AY,uchar BX,uchar BY);
    void SetPitch(uchar Pitch);
    void SetHeight(uchar Height);
    void InputString(STRING * String);
    void DrawBox(uchar AX,uchar AY,uchar BX,uchar BY,uchar TTTF);
    void DrawBlock(uchar AX,uchar AY,uchar BX,uchar BY,uchar TT);
    void DrawHoriz(uchar XPos,uchar YPos,char Length,uchar TT);
    void DrawVert(uchar XPos,uchar YPos,char Length,uchar TT);
    void DrawVector(uchar AX,uchar AY,uchar BX,uchar BY,uchar TT);
    void SetPixel(uchar XPos,uchar YPos,uchar TT);
    void MoveBlockVert(uchar AX,uchar AY,uchar BX,uchar BY,char Distance);
    void MoveBlockHoriz(uchar AX,uchar AY,uchar BX,uchar BY,char Distance);
    bool PlaceButton(uchar Code,uchar Col,uchar Row);
    void LoadButtonBuffer(STRING * String);
    bool GetButtonSize(uchar KeyCode,uchar * RData);
    bool PlacePhantomButton(uchar KeyCode,uchar Col,uchar Row,uchar Length);
    bool DeleteButton(uchar KeyCode);
    void DeleteAllButtons(void);
    uchar ReadKeyCode(void);
    void SetButtonAttribute(uchar abc);
    void SetButtonGrayPalet(uchar Palet);
    void SetButtonPlane(uchar Plane);
    void BlankDisplay(void);
    void ClearDisplay(void);
    void Refresh(void);
    void SetAutoRefresh(uchar ab);
    bool DumpDisplayRAM(STRING * sFileName);
    bool LoadDisplayRAM(STRING * sFileName);
    void LoadGrayDither(uchar GD1,uchar GD2);
    void ReverseVideo(bool bReverse);
    void SetGrayPalet(uchar Palet);
    void SetPlane(uchar Plane);
    void SoftReset(void);
    void SetContrast(uchar);
    void SetEL(uchar a);
    void NOP(void);
    void SetBeeper(uchar a);
    bool ReadKeyMatrix(uchar * RData);
    bool ReadAuxPort(uchar * pAuxData);
    void WriteAuxPort(uchar AuxData);
#ifdef __cplusplus
}
#endif

#endif /* _TVIO_H */
